<template>
	<div id="devicePlayer">
		<el-dialog title="视频播放" top="0" :visible.sync="showVideoDialog" :destroy-on-close="true" @close="stop()">
			<iframe :src="videoUrl" ref="videoRender" style="width:100%; height:35rem;" frameborder="no" border="0" marginwidth="0"
			 marginheight="0" scrolling="no" allowtransparency="yes"></iframe>
			<div id="shared" style="text-align: right;">
				<el-tabs>
					<el-tab-pane label="媒体流信息" name="media">
						<div style="margin-bottom: 0.5rem;">
							<el-button type="primary" size="small" @click="playRecord(true,'')">播放</el-button>
							<el-button type="primary" size="small" @click="startRecord()">录制</el-button>
							<el-button type="primary" size="small" @click="stopRecord()">停止录制</el-button>
						</div>
						<div style="display: flex; margin-bottom: 0.5rem; height: 2.5rem;">
							<span style="width: 5rem; line-height: 2.5rem; text-align: right;">播放地址：</span>
							<el-input v-model="getPlayerShared.sharedUrl" :disabled="true" v-on:click.native="copySharedInfo(getPlayerShared.sharedUrl)"></el-input>
						</div>
						<div style="display: flex; margin-bottom: 0.5rem; height: 2.5rem;">
							<span style="width: 5rem; line-height: 2.5rem; text-align: right;">iframe：</span>
							<el-input v-model="getPlayerShared.sharedIframe" :disabled="true" v-on:click.native="copySharedInfo(getPlayerShared.sharedIframe)"></el-input>
						</div>
						<div style="display: flex; margin-bottom: 0.5rem; height: 2.5rem;">
							<span style="width: 5rem; line-height: 2.5rem; text-align: right;">资源地址：</span>
							<el-input v-model="getPlayerShared.sharedRtmp" :disabled="true" v-on:click.native="copySharedInfo(getPlayerShared.sharedRtmp)"></el-input>
						</div>
					</el-tab-pane>
					<!--{"code":0,"data":{"paths":["22-29-30.mp4"],"rootPath":"/home/kkkkk/Documents/ZLMediaKit/release/linux/Debug/www/record/hls/kkkkk/2020-05-11/"}}-->
					<el-tab-pane label="录像查询" name="second">
						<el-table :data="videoHistory.searchHistoryResult" style="width: 100%">
							<el-table-column label="文件" prop="path" width="500">
							</el-table-column>
							<el-table-column align="right" width="300">
								<template slot="header" slot-scope="scope">
									<el-date-picker v-model="videoHistory.searchHistoryParam" type="date" placeholder="选择日期" @change="recordList()">
									</el-date-picker>
								</template>
							</el-table-column>
							<el-table-column label="">
								<template slot-scope="scope">
									<el-button type="primary" size="mini" @click="playRecord(false,scope.row)">播放</el-button>
								</template>
							</el-table-column>
						</el-table>
					</el-tab-pane>
					<!--遥控界面-->
					<el-tab-pane label="视频遥控" name="third">
						<div class="control-wrapper">
						    <div class="control-btn control-top">
						        <i class="fa fa-chevron-up"></i>
						        <div class="control-inner-btn control-inner"></div>
						    </div>
						    <div class="control-btn control-left">
						        <i class="fa fa-chevron-left"></i>
						        <div class="control-inner-btn control-inner"></div>
						    </div>
						    <div class="control-btn control-bottom">
						        <i class="fa fa-chevron-down"></i>
						        <div class="control-inner-btn control-inner"></div>
						    </div>
						    <div class="control-btn control-right">
						        <i class="fa fa-chevron-right"></i>
						        <div class="control-inner-btn control-inner"></div>
						    </div>
						    <div class="control-round">
						        <div class="control-round-inner">
						            <i class="fa fa-pause-circle"></i>
						        </div>
						    </div>
						</div>
					</el-tab-pane>
				</el-tabs>
			</div>
		</el-dialog>
	</div>

</template>

<script>
	export default {
		name: 'devicePlayer',
		props: {

		},
		computed: {
			getPlayerShared: function() {
				let info = {
					sharedUrl: window.location.host + '/' + this.videoUrl,
					sharedIframe: '<iframe src="' + window.location.host + '/' + this.videoUrl + '"></iframe>',
					sharedRtmp: this.videoUrl
				};
				return info;
			},
		},
		data() {
			return {
				videoUrl: '',
				videoHistory: {
					searchHistoryParam: "",
					searchHistoryResult: [], //媒体流历史记录搜索结果
				},
				showVideoDialog: false,
				normalssrc:'',
				ssrc: '',
			}
		},
		methods: {
			play: function(normalssrc) {
				this.normalssrc=normalssrc;
				let hex_ssrc = parseInt(normalssrc).toString(16);
				let hex_ssrc_size = 8 - hex_ssrc.length;
				for (var i = 0; i < hex_ssrc_size; i++) {
					hex_ssrc = "0" + hex_ssrc;
				}
				console.log("hex_ssrc:"+hex_ssrc);
				this.ssrc = hex_ssrc.toLocaleUpperCase();
				console.log("转换完成："+this.ssrc);
				this.videoUrl = '/video/video.html?url=' + this.$global.baseMediaUrl + 'rtp/' + this.ssrc + ".flv?st=" + new Date().getTime();
				this.showVideoDialog = true;
				console.log(this.ssrc);
			},
			stop: function() {
				console.log("关闭视频");
				this.videoUrl = '';
				this.showVideoDialog = false;
				let that = this;
				this.$axios({
					method: 'get',
					url: this.$global.genGb28181Url('/api/play/' + this.normalssrc + '/stop')
				}).then(function(res) {
					console.log(JSON.stringify(res));
				})
			},
			copySharedInfo: function(data) {
				console.log('复制内容：' + data);
				let _this = this;
				this.$copyText(data).then(
					function(e) {
						_this.$message({
							showClose: true,
							message: '复制成功',
							type: 'success'
						});
					},
					function(e) {
						_this.$message({
							showClose: true,
							message: '复制失败，请手动复制',
							type: 'error'
						});
					}
				);
			},
			startRecord: function() {
				let that = this;
				let startURL = this.$global.genApiUrl('/startRecord') + '&type=1&vhost=__defaultVhost__&app=rtp&stream=' + this.ssrc;
				console.log(startURL);
				this.$axios({
					method: 'get',
					url: startURL
				}).then(function(res) {
					console.log(JSON.stringify(res.data));
					if (res.data.code == 0 && res.data.result) {
						that.$message({
							showClose: true,
							message: '开始录制',
							type: 'success'
						});
					} else {
						that.$message({
							showClose: true,
							message: res.data.msg,
							type: 'error'
						});
					}
				});
			},
			stopRecord: function() {
				let that = this;
				let streamInfo = this.currentPlayerInfo;
				let stopURL = this.$global.genApiUrl('/stopRecord') + '&type=1&vhost=__defaultVhost__&app=rtp&stream=' + this.ssrc;
				console.log(stopURL);
				this.$axios({
					method: 'get',
					url: stopURL
				}).then(function(res) {
					console.log(JSON.stringify(res.data));
					if (res.data.code == 0 && res.data.result) {
						that.$message({
							showClose: true,
							message: '结束录制',
							type: 'success'
						});
					} else {
						that.$message({
							showClose: true,
							message: res.data.msg,
							type: 'error'
						});
					}
				});
			},
			recordList: function() {
				let that = this;
				console.log("当前ssrc："+this.ssrc);
				var date = this.videoHistory.searchHistoryParam;
				var year = date.getFullYear();
				var month = date.getMonth() + 1;
				var day = date.getDate();
				if (month < 10) {
					month = "0" + month;
				}
				if (day < 10) {
					day = "0" + day;
				}
				let nowDate = year + "-" + month + "-" + day;
				let stopURL = this.$global.genApiUrl('/getMp4RecordFile') + '&vhost=__defaultVhost__&app=rtp&stream=' + this.ssrc +
					'&period=' + nowDate;

				console.log(stopURL);
				this.$axios({
					method: 'get',
					url: stopURL
				}).then(function(res) {
					console.log(JSON.stringify(res.data));
					if (res.data.code == 0 && res.data) {
						let mp4files = res.data.data.paths;
						let rootPath = res.data.data.rootPath;
						let weburltemp = rootPath.substr(rootPath.indexOf("record"));
						let weburl = "http://" + that.$global.ZLServerIp + "/" + weburltemp;
						for (let i in mp4files) {
							let fullMp4file = weburl + mp4files[i]
							console.log(fullMp4file);
							that.videoHistory.searchHistoryResult.push({
								"path": fullMp4file
							});
						};
						that.$message({
							showClose: true,
							message: '列表获取成功',
							type: 'success'
						});
					} else {
						that.$message({
							showClose: true,
							message: res.data.msg,
							type: 'error'
						});
					}
				});
			},
			playRecord: function(isBackLive, rowData) {
				console.log(JSON.stringify(rowData));
				this.$refs.videoRender.contentWindow.postMessage({
					cmd: 'switchUrl',
					params: isBackLive ? {
						"path": this.videoUrl.replace("/video/video.html?url=","")
					} : rowData
				}, '*')
			},
		}
	}
</script>

<style>
	.control-wrapper {position: relative;width: 30vw;height: 30vw;max-width: 100px;max-height: 100px;margin: 0 auto;border-radius: 100%;}
	 
	.control-btn {display: flex;justify-content: center;position: absolute; width: 44%; height: 44%; border-radius: 5px; border: 1px solid #78aee4; box-sizing: border-box;  transition: all .3s linear;  }
	 
	.control-btn i {font-size: 20px; color: #78aee4;  display: flex; justify-content: center; align-items: center;}
	 
	.control-round {position: absolute; top: 21%; left: 21%; width: 58%; height: 58%; background: #fff; border-radius: 100%;}
	 
	.control-round-inner {  position: absolute;  left: 15%;  top: 15%;  display: flex; justify-content: center; align-items: center;  width: 70%; height: 70%; font-size: 40px; color: #78aee4; border: 1px solid #78aee4; border-radius: 100%;  transition: all .3s linear; }
	 
	.control-inner-btn {position: absolute; width: 60%; height: 60%; background: #fafafa;}
	 
	.control-top {top: -8%; left: 27%; transform: rotate(-45deg); border-radius: 5px 100% 5px 0;}
	 
	.control-top .control-inner {left: -1px;  bottom: 0;  border-top: 1px solid #78aee4;  border-right: 1px solid #78aee4;  border-radius: 0 100% 0 0;  }
	 
	.control-top .fa {transform: rotate(45deg) translateY(-7px); }
	 
	.control-left {top: 27%;  left: -8%;  transform: rotate(45deg);  border-radius: 5px 0 5px 100%;}
	 
	.control-left .control-inner {right: -1px;  top: -1px;  border-bottom: 1px solid #78aee4;  border-left: 1px solid #78aee4;  border-radius: 0 0 0 100%;}
	 
	.control-left .fa {transform: rotate(-45deg) translateX(-7px);}
	 
	.control-right {top: 27%;  right: -8%;  transform: rotate(45deg);  border-radius: 5px 100% 5px 0; }
	 
	.control-right .control-inner {left: -1px;  bottom: -1px;  border-top: 1px solid #78aee4;  border-right: 1px solid #78aee4;  border-radius: 0 100% 0 0 ;}
	 
	.control-right .fa {transform: rotate(-45deg) translateX(7px);}
	 
	.control-bottom {left: 27%;  bottom: -8%;  transform: rotate(45deg);  border-radius: 0 5px 100% 5px;  }
	 
	.control-bottom .control-inner {top: -1px;  left: -1px;  border-bottom: 1px solid #78aee4;  border-right: 1px solid #78aee4;  border-radius: 0 0 100% 0 ;}
	 
	.control-bottom .fa {  transform: rotate(-45deg) translateY(7px);  }
</style>
